uses crt;

const Unmoeglich    = MaxInt;
      Umsteigen     =      0;
      MaxLinien     =     10;
      MaxBahnhoefe  =    100;
      MaxFahrplaene =     20;

type tBahnhofstyp = (Umsteigepunkt, Bahnsteig);
     tStreckentyp = (Normal, Umsteigestrecke);
     tVerbindung  = record
                       Bahnhofsnummer       : integer;
                       Zeit                 : real;
                       Typ                  : tStreckentyp;
                    end;
     tBahnhof     = record
                       Name                 : string;
                       Typ                  : tBahnhofstyp;
                       Linie                : integer;
                       AnzahlVerbindungen   : integer;
                       Verbindung           : array[1..MaxLinien] of tVerbindung;
                    end;
     tLinie       = record
                       Name                 : string;
                    end;
     tGraph       = record
                       AnzahlLinien         : integer;
                       Linie                : array[0..MaxLinien] of tLinie;
                       AnzahlBahnhoefe      : integer;
                       Bahnhof              : array[1..MaxBahnhoefe] of tBahnhof;
                    end;
     tOptimierung = array[1..MaxBahnhoefe] of
                       record
                          AnkunftsZeit      : real;
                          AbfahrtsZeit      : real;
                          AnzahlVorgaenger  : integer;
                          Vorgaengernummer  : array[1..MaxLinien] of integer;
                          Minimal           : boolean;
                       end;

var Graph           : tGraph;
    Optimierung     : tOptimierung;
    Fahrzeit        : real;
    Umsteigezeit    : real;
    Aufenthaltszeit : real;
    Von, Nach       : integer;


function IdentifiziereNamen(Name: string; Linie: integer): integer;
var Zaehler: integer;
begin
   IdentifiziereNamen:=Unmoeglich;

   for Zaehler:=1 to Graph.AnzahlBahnhoefe do
      if Graph.Bahnhof[Zaehler].Name=Name then
         if (Linie=Unmoeglich) or (Linie=Graph.Bahnhof[Zaehler].Linie) then
         begin
            IdentifiziereNamen:=Zaehler;
            break;
         end;
end;


function IdentifiziereNummer(Nummer: integer): string;
begin
   IdentifiziereNummer:=Graph.Bahnhof[Nummer].Name;
end;


procedure GraphErstellen(DateiName: string);
var Datei            : text;
    Einlesen         : string;
    LetzterBahnhof   : integer;
    AktuellerBahnhof : integer;
    AktuelleLinie    : integer;
    Zaehler          : integer;
    Lauf             : integer;
    Umsteigebahnhof  : integer;
begin
   assign(Datei,DateiName);
   reset(Datei);

   with Graph do
   begin
      Linie[0].Name:='umsteigen';

      AnzahlLinien:=0;
      AnzahlBahnhoefe:=0;

      readln(Datei,Einlesen);
      while Einlesen<>'' do
      begin
         inc(AnzahlLinien);
         Linie[AnzahlLinien].Name:=Einlesen;

         readln(Datei,Einlesen);
         while Einlesen<>'' do
         begin
            if (IdentifiziereNamen(Einlesen,Unmoeglich)=Unmoeglich) or
               (Bahnhof[IdentifiziereNamen(Einlesen,Unmoeglich)].Linie<>AnzahlLinien) then
            begin
               inc(AnzahlBahnhoefe);
               Bahnhof[AnzahlBahnhoefe].Name:=Einlesen;
               Bahnhof[AnzahlBahnhoefe].Typ:=Bahnsteig;
               Bahnhof[AnzahlBahnhoefe].Linie:=AnzahlLinien;
               Bahnhof[AnzahlBahnhoefe].AnzahlVerbindungen:=0;
            end;
            readln(Datei,Einlesen);
         end;
         readln(Datei,Einlesen);
      end;

      reset(Datei);

      AktuelleLinie:=0;
      readln(Datei,Einlesen);
      while Einlesen<>'' do
      begin
         inc(AktuelleLinie);

         readln(Datei,Einlesen);

         LetzterBahnhof:=IdentifiziereNamen(Einlesen,AktuelleLinie);
         readln(Datei,Einlesen);
         while Einlesen<>'' do
         begin
            AktuellerBahnhof:=IdentifiziereNamen(Einlesen,AktuelleLinie);

            inc(Bahnhof[LetzterBahnhof].AnzahlVerbindungen);
            Bahnhof[LetzterBahnhof].Verbindung[Bahnhof[LetzterBahnhof].AnzahlVerbindungen].Bahnhofsnummer:=AktuellerBahnhof;
            Bahnhof[LetzterBahnhof].Verbindung[Bahnhof[LetzterBahnhof].AnzahlVerbindungen].Zeit:=Fahrzeit;
            Bahnhof[LetzterBahnhof].Verbindung[Bahnhof[LetzterBahnhof].AnzahlVerbindungen].Typ:=Normal;
            inc(Bahnhof[AktuellerBahnhof].AnzahlVerbindungen);
            Bahnhof[AktuellerBahnhof].Verbindung[Bahnhof[AktuellerBahnhof].AnzahlVerbindungen].Bahnhofsnummer:=LetzterBahnhof;
            Bahnhof[AktuellerBahnhof].Verbindung[Bahnhof[AktuellerBahnhof].AnzahlVerbindungen].Zeit:=Fahrzeit;
            Bahnhof[AktuellerBahnhof].Verbindung[Bahnhof[AktuellerBahnhof].AnzahlVerbindungen].Typ:=Normal;

            LetzterBahnhof:=AktuellerBahnhof;

            readln(Datei,Einlesen);
         end;
         readln(Datei,Einlesen);
      end;
      close(Datei);

      LetzterBahnhof:=AnzahlBahnhoefe;
      for Zaehler:=1 to LetzterBahnhof-1 do
         for Lauf:=Zaehler+1 to LetzterBahnhof do
            if Bahnhof[Zaehler].Name=Bahnhof[Lauf].Name then
               if IdentifiziereNamen(Bahnhof[Zaehler].Name,Umsteigen)=Unmoeglich then
               begin
                  inc(AnzahlBahnhoefe);
                  Bahnhof[AnzahlBahnhoefe].Name:=Bahnhof[Zaehler].Name;
                  Bahnhof[AnzahlBahnhoefe].Typ:=Umsteigepunkt;
                  Bahnhof[AnzahlBahnhoefe].Linie:=Umsteigen;
                  Bahnhof[AnzahlBahnhoefe].AnzahlVerbindungen:=0;
               end;

      for Zaehler:=1 to LetzterBahnhof do
      begin
         UmsteigeBahnhof:=IdentifiziereNamen(Bahnhof[Zaehler].Name,Umsteigen);
         if UmsteigeBahnhof<>Unmoeglich then
         begin
            inc(Bahnhof[Zaehler].AnzahlVerbindungen);
            Bahnhof[Zaehler].Verbindung[Bahnhof[Zaehler].AnzahlVerbindungen].Bahnhofsnummer:=UmsteigeBahnhof;
            Bahnhof[Zaehler].Verbindung[Bahnhof[Zaehler].AnzahlVerbindungen].Zeit:=0;
            Bahnhof[Zaehler].Verbindung[Bahnhof[Zaehler].AnzahlVerbindungen].Typ:=Umsteigestrecke;
            inc(Bahnhof[UmsteigeBahnhof].AnzahlVerbindungen);
            Bahnhof[UmsteigeBahnhof].Verbindung[Bahnhof[UmsteigeBahnhof].AnzahlVerbindungen].Bahnhofsnummer:=Zaehler;
            Bahnhof[UmsteigeBahnhof].Verbindung[Bahnhof[UmsteigeBahnhof].AnzahlVerbindungen].Zeit:=0;
         end;
      end;
   end;
end;


function Suche(Start, Ziel: string): boolean;

    procedure OptimiereAngrenzendeVerbindungen(Ausgehend: integer);
    var Zaehler      : integer;
        AusgangsZeit : real;
        LokalesZiel  : integer;
        Aufenthalt   : real;
    begin
       for Zaehler:=1 to Graph.Bahnhof[Ausgehend].AnzahlVerbindungen do
       begin
          if Graph.Bahnhof[Ausgehend].Verbindung[Zaehler].Typ=Umsteigestrecke then
             Aufenthalt:=Umsteigezeit-2*AufenthaltsZeit
          else
             Aufenthalt:=AufenthaltsZeit;

          AusgangsZeit:=Optimierung[Ausgehend].AbfahrtsZeit+Graph.Bahnhof[Ausgehend].Verbindung[Zaehler].Zeit;
          LokalesZiel:=Graph.Bahnhof[Ausgehend].Verbindung[Zaehler].Bahnhofsnummer;

          if AusgangsZeit<Optimierung[LokalesZiel].AnkunftsZeit then
          begin
             Optimierung[LokalesZiel].AnkunftsZeit:=AusgangsZeit;
             Optimierung[LokalesZiel].AbfahrtsZeit:=AusgangsZeit+Aufenthalt;
             Optimierung[LokalesZiel].AnzahlVorgaenger:=1;
             Optimierung[LokalesZiel].Vorgaengernummer[1]:=Ausgehend;
          end
          else
             if AusgangsZeit=Optimierung[LokalesZiel].AnkunftsZeit then
             begin
                inc(Optimierung[LokalesZiel].AnzahlVorgaenger);
                Optimierung[LokalesZiel].Vorgaengernummer[Optimierung[LokalesZiel].AnzahlVorgaenger]:=Ausgehend;
             end;
       end;
    end;


    function FindeOptimierbarenBahnhof: integer;
    var Zaehler        : integer;
        KuerzesteZeit  : real;
        Bahnhofsnummer : integer;
    begin
       KuerzesteZeit:=Optimierung[Nach].AnkunftsZeit;
       Bahnhofsnummer:=Unmoeglich;

       for Zaehler:=1 to Graph.AnzahlBahnhoefe do
          if not Optimierung[Zaehler].Minimal and
             (Optimierung[Zaehler].AbfahrtsZeit<=KuerzesteZeit) then
          begin
             KuerzesteZeit:=Optimierung[Zaehler].AbfahrtsZeit;
             Bahnhofsnummer:=Zaehler;
          end;

       FindeOptimierbarenBahnhof:=Bahnhofsnummer;
    end;


var Zaehler          : integer;
    AktuellerBahnhof : integer;
    LokalesZiel      : integer;

begin
   Von:=IdentifiziereNamen(Start,Umsteigen);
   if Von=Unmoeglich then
      Von:=IdentifiziereNamen(Start,Unmoeglich);
   Nach:=IdentifiziereNamen(Ziel,Umsteigen);
   if Nach=Unmoeglich then
      Nach:=IdentifiziereNamen(Ziel,Unmoeglich);

   for Zaehler:=1 to Graph.AnzahlBahnhoefe do
   begin
      Optimierung[Zaehler].AnkunftsZeit:=Unmoeglich;
      Optimierung[Zaehler].AbfahrtsZeit:=Unmoeglich;
      Optimierung[Zaehler].AnzahlVorgaenger:=0;
      Optimierung[Zaehler].Minimal:=false;
   end;

   Optimierung[Von].AnkunftsZeit:=0;
   Optimierung[Von].AbfahrtsZeit:=0;
   Optimierung[Von].Minimal:=true;
   if IdentifiziereNamen(Start,Umsteigen)<>Unmoeglich then
      for Zaehler:=1 to Graph.Bahnhof[Von].AnzahlVerbindungen do
      begin
          LokalesZiel:=Graph.Bahnhof[Von].Verbindung[Zaehler].Bahnhofsnummer;
          Optimierung[LokalesZiel].AnkunftsZeit:=0;
          Optimierung[LokalesZiel].AbfahrtsZeit:=0;
          Optimierung[LokalesZiel].AnzahlVorgaenger:=1;
          Optimierung[LokalesZiel].Vorgaengernummer[1]:=Von;
          Optimierung[LokalesZiel].Minimal:=true;

          OptimiereAngrenzendeVerbindungen(LokalesZiel);
      end
   else
      OptimiereAngrenzendeVerbindungen(Von);

   repeat
      AktuellerBahnhof:=FindeOptimierbarenBahnhof;
      if AktuellerBahnhof<>Unmoeglich then
      begin
         Optimierung[AktuellerBahnhof].Minimal:=true;
         OptimiereAngrenzendeVerbindungen(AktuellerBahnhof);
      end;
   until AktuellerBahnhof=Unmoeglich;

   Suche:=Optimierung[Nach].AnkunftsZeit<Unmoeglich;
end;


procedure ZeigeAlleVarianten;
type tFahrplan        = record
                           Stationen : integer;
                           Liste     : array[1..MaxBahnhoefe] of integer;
                        end;
var Fahrplaene        : array[1..MaxFahrplaene] of tFahrplan;
    AnzahlFahrplaene  : integer;
    StartFahrplan     : tFahrplan;
    AktuellerBahnhof  : integer;
    BahnhofZaehler    : integer;
    AktuellerFahrplan : integer;
    ZielBahnhof       : integer;

   procedure FindeVorgaenger(Fahrplan: tFahrplan; Position: integer);
   var Zaehler : integer;
   begin
      if Fahrplan.Liste[Position]=Von then
      begin
         Fahrplan.Stationen:=Position;
         inc(AnzahlFahrplaene);
         Fahrplaene[AnzahlFahrplaene]:=Fahrplan;
      end
      else
         for Zaehler:=1 to Optimierung[Fahrplan.Liste[Position]].AnzahlVorgaenger do
         begin
            Fahrplan.Liste[Position+1]:=Optimierung[Fahrplan.Liste[Position]].Vorgaengernummer[Zaehler];
            FindeVorgaenger(Fahrplan,Position+1);
         end;
   end;


begin
   AnzahlFahrplaene:=0;
   StartFahrplan.Liste[1]:=Nach;
   FindeVorgaenger(StartFahrplan,1);

   writeln;
   if AnzahlFahrplaene=1 then
      writeln(AnzahlFahrplaene,' Fahrplan gefunden !')
   else
      writeln(AnzahlFahrplaene,' Fahrplne gefunden !');

   readln;

   for AktuellerFahrplan:=1 to AnzahlFahrplaene do
   with Graph do
   begin
      clrscr;

      BahnhofZaehler:=Fahrplaene[AktuellerFahrplan].Stationen;
      if Bahnhof[Fahrplaene[AktuellerFahrplan].Liste[BahnhofZaehler]].Typ=Umsteigepunkt then
         dec(BahnhofZaehler);

      ZielBahnhof:=0;
      if Bahnhof[Fahrplaene[AktuellerFahrplan].Liste[1]].Typ=Umsteigepunkt then
         ZielBahnhof:=1;

      writeln('Fahrplan ',AktuellerFahrplan,':');
      writeln('         Linie         Zeit   Bahnhof');
      writeln;
      writeln('           Start');
      repeat
         AktuellerBahnhof:=Fahrplaene[AktuellerFahrplan].Liste[BahnhofZaehler];

         if Optimierung[Fahrplaene[AktuellerFahrplan].Liste[BahnhofZaehler]].AnkunftsZeit>0 then
         begin
            write('an    ',Linie[Bahnhof[AktuellerBahnhof].Linie].Name:10,'    ');
            write('  ',trunc(Optimierung[Fahrplaene[AktuellerFahrplan].Liste[BahnhofZaehler]].AnkunftsZeit):2);
            write('.');
            if frac(Optimierung[Fahrplaene[AktuellerFahrplan].Liste[BahnhofZaehler]].AnkunftsZeit)*60<10 then
               write('0');
            write(frac(Optimierung[Fahrplaene[AktuellerFahrplan].Liste[BahnhofZaehler]].AnkunftsZeit)*60:0:0);

            writeln('   ',IdentifiziereNummer(Fahrplaene[AktuellerFahrplan].Liste[BahnhofZaehler]));
         end;

         if BahnhofZaehler-2>ZielBahnhof then
            if Bahnhof[Fahrplaene[AktuellerFahrplan].Liste[BahnhofZaehler-1]].Typ=Umsteigepunkt then
            begin
               writeln('       umsteigen');
               dec(BahnhofZaehler,2);
               AktuellerBahnhof:=Fahrplaene[AktuellerFahrplan].Liste[BahnhofZaehler];
            end;

         if BahnhofZaehler-1>ZielBahnhof then
         begin
            write('ab    ',Linie[Bahnhof[AktuellerBahnhof].Linie].Name:10,'    ');
            write('  ',trunc(Optimierung[Fahrplaene[AktuellerFahrplan].Liste[BahnhofZaehler]].AbfahrtsZeit):2);
            write('.');
            if frac(Optimierung[Fahrplaene[AktuellerFahrplan].Liste[BahnhofZaehler]].AbfahrtsZeit)*60<10 then
               write('0');
            write(frac(Optimierung[Fahrplaene[AktuellerFahrplan].Liste[BahnhofZaehler]].AbfahrtsZeit)*60:0:0);

            writeln('   ',IdentifiziereNummer(Fahrplaene[AktuellerFahrplan].Liste[BahnhofZaehler]));
         end;

         dec(BahnhofZaehler);
      until BahnhofZaehler=ZielBahnhof;
      writeln('            Ziel');

      readln;
   end;
end;


procedure Auswahl;
var Eingabe : integer;
    Lauf    : integer;
    Linie   : integer;
    Start   : string;
    Ziel    : string;
begin
   repeat
      clrscr;
      writeln('Ende mit [Enter], Auswahl ber Liste mit 0 !');
      write('von  ');

      readln(Start);
      if Start='' then
         exit;
      if Start<>'0' then
      begin
         if IdentifiziereNamen(Start,Unmoeglich)=Unmoeglich then
         begin
            writeln('Bahnhof '''+Start+''' nicht gefunden !');
            readln;
            continue;
         end;

         write('nach ');
         readln(Ziel);
         if IdentifiziereNamen(Ziel,Unmoeglich)=Unmoeglich then
         begin
            writeln('Bahnhof '''+Ziel+''' nicht gefunden !');
            readln;
            continue;
         end;
      end
      else
      begin
         for Lauf:=1 to Graph.AnzahlLinien do
            writeln(Lauf:8,'  ',Graph.Linie[Lauf].Name);
         write('Startlinie: ');
         readln(Linie);

         writeln('Bahnhfe der Linie ',Graph.Linie[Linie].Name,':');
         for Lauf:=1 to Graph.AnzahlBahnhoefe do
            if Graph.Bahnhof[Lauf].Linie=Linie then
               writeln(Lauf:8,'  ',Graph.Bahnhof[Lauf].Name);

         write('Startbahnhof: ');
         readln(Eingabe);
         Start:=Graph.Bahnhof[Eingabe].Name;
         writeln;

         for Lauf:=1 to Graph.AnzahlLinien do
            writeln(Lauf:8,'  ',Graph.Linie[Lauf].Name);
         write('Ziellinie: ');
         readln(Linie);

         writeln('Bahnhfe der Linie ',Graph.Linie[Linie].Name,':');
         for Lauf:=1 to Graph.AnzahlBahnhoefe do
            if Graph.Bahnhof[Lauf].Linie=Linie then
               writeln(Lauf:8,'  ',Graph.Bahnhof[Lauf].Name);

         write('Zielbahnhof: ');
         readln(Eingabe);
         Ziel:=Graph.Bahnhof[Eingabe].Name;
      end;

      if Start=Ziel then
      begin
         writeln('Start gleich Ziel !');
         readln;
         continue;
      end;

      if Suche(Start,Ziel) then
         ZeigeAlleVarianten
      else
      begin
         writeln('Keine Verbindung gefunden !');
         readln;
      end;
   until 1=2;
end;


begin
   Fahrzeit:=1;
   Aufenthaltszeit:=30/60;

   repeat
      write('Umsteigezeit (in Minuten): ');
      readln(Umsteigezeit);
   until Umsteigezeit>2*Aufenthaltszeit;

   GraphErstellen('AUFGABE1.G01');

   Auswahl;
end.