uses crt,graph;

const AbschnittsLaenge      =    7.5;
      MaxStrassenAbschnitte =   1000;
      MaxSpuren             =      5;
      MaxNormalTempo        =      5;
      MaxUeberholTempo      =      6;
      Vorwaerts             =      1;
      Rueckwaerts           =     -1;

type tAuto      = (PKW,LKW,leer);
     tAbschnitt = record
                     Benutzt         : tAuto;
                     Geschwindigkeit : byte;
                     Gesperrt        : (ja,nein,RechteSpur);
                     Verkehrsfluss   : real;
                     MaxTempo        : byte;
                  end;
     tStrasse   = array[1..MaxSpuren,-MaxUeberholTempo..MaxStrassenAbschnitte+MaxUeberholTempo] of tAbschnitt;

var Strasse          : ^tStrasse;
    Troedler         : real;
    Verkehrsdichte   : real;
    Nachrueckdichte  : real;
    LKWDichte        : real;
    StrassenLaenge   : real;
    StrassenGroesse  : longint;
    AnzahlAbschnitte : longint;
    AnzahlSpuren     : longint;

    FlipPages        : byte;


function ErmittleAbstand(Spur,Abschnitt: longint; Richtung: longint): byte;
var Abstand  : byte;
begin
   Abstand:=0;
   repeat
      inc(Abstand);
   until (Strasse^[Spur,Abschnitt+Richtung*Abstand].Benutzt<>leer) or
         (Abstand>Strasse^[Spur,Abschnitt+Richtung*Abstand].MaxTempo);
   ErmittleAbstand:=Abstand-1;
end;


procedure ErzeugeVerkehrslage;
var AbschnittsZaehler : longint;
    SpurenZaehler     : longint;
begin
   new(Strasse);
   fillchar(Strasse^,sizeof(Strasse^),0);

   for SpurenZaehler:=AnzahlSpuren downto 1 do
      for AbschnittsZaehler:=-MaxUeberholTempo to AnzahlAbschnitte+MaxUeberholTempo do
      begin
         Strasse^[SpurenZaehler,AbschnittsZaehler].Geschwindigkeit:=0;
         Strasse^[SpurenZaehler,AbschnittsZaehler].Benutzt:=leer;
         if SpurenZaehler=1 then
         begin
             Strasse^[SpurenZaehler,AbschnittsZaehler].Gesperrt:=RechteSpur;
             Strasse^[SpurenZaehler,AbschnittsZaehler].MaxTempo:=MaxNormalTempo;
         end
         else
         begin
             Strasse^[SpurenZaehler,AbschnittsZaehler].Gesperrt:=nein;
             Strasse^[SpurenZaehler,AbschnittsZaehler].MaxTempo:=MaxUeberholTempo;
         end;
      end;

   for SpurenZaehler:=AnzahlSpuren downto 1 do
      for AbschnittsZaehler:=AnzahlAbschnitte downto 1 do
         if random<=Verkehrsdichte then
         begin
            Strasse^[SpurenZaehler,AbschnittsZaehler].Geschwindigkeit:=
                  ErmittleAbstand(SpurenZaehler,AbschnittsZaehler,Vorwaerts);
            if (SpurenZaehler=1) and (random<=LKWDichte) then
               Strasse^[SpurenZaehler,AbschnittsZaehler].Benutzt:=LKW
            else
               Strasse^[SpurenZaehler,AbschnittsZaehler].Benutzt:=PKW;
         end;
end;


procedure ErgaenzeVerkehrslage;
var AbschnittsZaehler : longint;
    SpurenZaehler     : byte;
    VorgaengerAuto    : longint;
begin
   for SpurenZaehler:=AnzahlSpuren downto 1 do
   begin
      VorgaengerAuto:=ErmittleAbstand(SpurenZaehler,1,Vorwaerts);

      if VorgaengerAuto=0 then
         exit;

      for AbschnittsZaehler:=VorgaengerAuto downto 1 do
         if random<=Nachrueckdichte then
         begin
            Strasse^[SpurenZaehler,AbschnittsZaehler].Geschwindigkeit:=
                  ErmittleAbstand(SpurenZaehler,AbschnittsZaehler,Vorwaerts);
            if (SpurenZaehler=1) and (random<=LKWDichte) then
               Strasse^[SpurenZaehler,AbschnittsZaehler].Benutzt:=LKW
            else
               Strasse^[SpurenZaehler,AbschnittsZaehler].Benutzt:=PKW;
         end;
   end;

   for SpurenZaehler:=AnzahlSpuren downto 1 do
      for AbschnittsZaehler:=AnzahlAbschnitte downto 1 do
      begin
         if Strasse^[SpurenZaehler,AbschnittsZaehler].Verkehrsfluss<0 then
            if (Strasse^[SpurenZaehler,AbschnittsZaehler].Benutzt<>leer) and
               (random<=abs(Strasse^[SpurenZaehler,AbschnittsZaehler].Verkehrsfluss)) then
            begin
               Strasse^[SpurenZaehler,AbschnittsZaehler].Benutzt:=leer;
               Strasse^[SpurenZaehler,AbschnittsZaehler].Geschwindigkeit:=0;
            end;

         if Strasse^[SpurenZaehler,AbschnittsZaehler].Verkehrsfluss>0 then
            if (Strasse^[SpurenZaehler,AbschnittsZaehler].Benutzt=leer) and
               (random<=Strasse^[SpurenZaehler,AbschnittsZaehler].Verkehrsfluss) then
            begin
               Strasse^[SpurenZaehler,AbschnittsZaehler].Geschwindigkeit:=
                   ErmittleAbstand(SpurenZaehler,AbschnittsZaehler,Vorwaerts);
               if (SpurenZaehler=1) and (random<=LKWDichte) then
                  Strasse^[SpurenZaehler,AbschnittsZaehler].Benutzt:=LKW
               else
                  Strasse^[SpurenZaehler,AbschnittsZaehler].Benutzt:=PKW;
            end;
      end;
end;


procedure SimuliereVerkehrslage;
var AbschnittsZaehler : longint;
    NeuerAbschnitt    : longint;
    NeueSpur          : longint;
    SpurenZaehler     : longint;
    Abstand           : byte;
    Geschwindigkeit   : byte;
    Autotyp           : tAuto;
    Beschleunigt      : boolean;
    Spurwechsel       : boolean;
begin
   for SpurenZaehler:=1 to AnzahlSpuren do
      for AbschnittsZaehler:=AnzahlAbschnitte downto 1 do
         if (Strasse^[SpurenZaehler,AbschnittsZaehler].Benutzt<>leer) and
            (Strasse^[SpurenZaehler,AbschnittsZaehler].Gesperrt<>ja) then
         begin
            Geschwindigkeit:=Strasse^[SpurenZaehler,AbschnittsZaehler].Geschwindigkeit;
            Autotyp:=Strasse^[SpurenZaehler,AbschnittsZaehler].Benutzt;
            Strasse^[SpurenZaehler,AbschnittsZaehler].Benutzt:=leer;
            Strasse^[SpurenZaehler,AbschnittsZaehler].Geschwindigkeit:=0;

            NeuerAbschnitt:=AbschnittsZaehler+Geschwindigkeit;
            if NeuerAbschnitt>AnzahlAbschnitte then
               continue;

            NeueSpur:=SpurenZaehler;
            Spurwechsel:=false;
            if NeueSpur>1 then
               if (Strasse^[NeueSpur-1,NeuerAbschnitt].Benutzt=leer) then
                  if ErmittleAbstand(NeueSpur-1,NeuerAbschnitt,Rueckwaerts)>
                     Strasse^[NeueSpur-1,NeuerAbschnitt-Abstand-1].Geschwindigkeit then
                     if ErmittleAbstand(NeueSpur-1,NeuerAbschnitt,Vorwaerts)>Geschwindigkeit then
                     begin
                        dec(NeueSpur);
                        Spurwechsel:=true;
                     end;

            Beschleunigt:=false;
            Abstand:=ErmittleAbstand(NeueSpur,NeuerAbschnitt,Vorwaerts);
            if Abstand>Geschwindigkeit then
            begin
               inc(Geschwindigkeit);
               Beschleunigt:=true;
            end
            else
            begin
               if Autotyp=PKW then
               begin
                  if (NeueSpur<AnzahlSpuren) and (not Spurwechsel) and
                     (Strasse^[NeueSpur,NeuerAbschnitt+Abstand].Geschwindigkeit<=Geschwindigkeit) then
                     if Strasse^[NeueSpur+1,NeuerAbschnitt].Benutzt=leer then
                        if Geschwindigkeit>=Strasse^[NeueSpur,NeuerAbschnitt-Abstand-1].Geschwindigkeit then
                           inc(NeueSpur);
               end
               else
                  if (Strasse^[NeueSpur,NeuerAbschnitt+Abstand+1].Gesperrt=ja) and
                     ((NeueSpur<AnzahlSpuren) and (not Spurwechsel)) then
                     if Strasse^[NeueSpur+1,NeuerAbschnitt].Benutzt=leer then
                        if Geschwindigkeit>=Strasse^[NeueSpur,NeuerAbschnitt-Abstand-1].Geschwindigkeit then
                           inc(NeueSpur);

               Geschwindigkeit:=ErmittleAbstand(NeueSpur,NeuerAbschnitt,Vorwaerts);
            end;

            if random<=Troedler then
            begin
               if Beschleunigt then
                  dec(Geschwindigkeit);
               if Geschwindigkeit>0 then
                  dec(Geschwindigkeit);
            end;

            if NeuerAbschnitt<=MaxStrassenAbschnitte then
            begin
               Strasse^[NeueSpur,NeuerAbschnitt].Benutzt:=Autotyp;
               Strasse^[NeueSpur,NeuerAbschnitt].Geschwindigkeit:=Geschwindigkeit;
            end;
         end;
end;


procedure ZeigeVerkehrslage;
var AbschnittsZaehler     : longint;
    SpurenZaehler         : longint;
    Autos                 : longint;
    Geschwindigkeitssumme : longint;
    Zeichenkette          : string;
begin
   Autos:=0;
   Geschwindigkeitssumme:=0;

   setactivepage(FlipPages);
   FlipPages:=1-FlipPages;
   setvisualpage(FlipPages);

   setviewport(250,0,350,70,false);
   clearviewport;
   setviewport(0,0,639,349,true);

   for SpurenZaehler:=AnzahlSpuren downto 1 do
   begin
      for AbschnittsZaehler:=1 to AnzahlAbschnitte do
      begin
         putpixel(AbschnittsZaehler,350-Spurenzaehler*50,black);

         if Strasse^[SpurenZaehler,AbschnittsZaehler].Benutzt<>leer then
         begin
            inc(Autos);
            inc(Geschwindigkeitssumme,Strasse^[SpurenZaehler,AbschnittsZaehler].Geschwindigkeit);

            case Strasse^[SpurenZaehler,AbschnittsZaehler].Geschwindigkeit of
               0: putpixel(AbschnittsZaehler,350-Spurenzaehler*50,red);
               1: putpixel(AbschnittsZaehler,350-Spurenzaehler*50,brown);
               3..MaxUeberholTempo:
                  if Strasse^[SpurenZaehler,AbschnittsZaehler].Benutzt=PKW then
                     putpixel(AbschnittsZaehler,350-Spurenzaehler*50,white)
                  else
                     putpixel(AbschnittsZaehler,350-Spurenzaehler*50,lightblue);
            end;
         end;
         if Strasse^[SpurenZaehler,AbschnittsZaehler].Gesperrt=ja then
            putpixel(AbschnittsZaehler,350-Spurenzaehler*50,yellow);
         if Strasse^[SpurenZaehler,AbschnittsZaehler].Gesperrt=RechteSpur then
            putpixel(AbschnittsZaehler,350-Spurenzaehler*50+7,blue);
         if Strasse^[SpurenZaehler,AbschnittsZaehler].Verkehrsfluss<0 then
            putpixel(AbschnittsZaehler,350-Spurenzaehler*50+5,lightgreen);
         if Strasse^[SpurenZaehler,AbschnittsZaehler].Verkehrsfluss>0 then
            putpixel(AbschnittsZaehler,350-Spurenzaehler*50+5,lightred);
      end;
   end;

   setcolor(white);
   str(Autos:5,Zeichenkette);
   outtextxy(0, 0,'Anzahl Autos                 : '+Zeichenkette);
   str(Geschwindigkeitssumme/Autos:8:2,Zeichenkette);
   outtextxy(0,20,'Durchschnittsgeschwindigkeit : '+Zeichenkette);
   str(Geschwindigkeitssumme:5,Zeichenkette);
   outtextxy(0,40,'Geschwindigkeitsindex        : '+Zeichenkette);
   str(100*Autos/StrassenGroesse:8:2,Zeichenkette);
   outtextxy(0,60,'Tatschliche Verkehrsdichte  : '+Zeichenkette+' %');
end;



var Treiber,Modus    : integer;
    Zeichen          : char;
    AnzahlUnfaelle   : longint;
    AnzahlEinfahrten : longint;
    Verkehrsfluss    : real;
    Zaehler,Lauf     : longint;
    Spur,Abschnitt   : longint;
begin
   randomize;

   Verkehrsdichte:=0.4;
   Nachrueckdichte:=1.7;
   LKWDichte:=0.4;
   Troedler:=0.2;
   StrassenLaenge:=4500;
   AnzahlSpuren:=3;
   AnzahlAbschnitte:=round(StrassenLaenge/AbschnittsLaenge);
   StrassenGroesse:=AnzahlSpuren*AnzahlAbschnitte;

   clrscr;
   write('Anzahl Spuren : ');
   readln(AnzahlSpuren);

   ErzeugeVerkehrslage;

   write('Anzahl Unflle/Baustellen : ');
   readln(AnzahlUnfaelle);
   if AnzahlUnfaelle>0 then
      for Zaehler:=1 to AnzahlUnfaelle do
      begin
         writeln(Zaehler,'.Unfall/Baustelle');

         write('   Spur (max.',AnzahlSpuren,') : ');
         readln(Spur);
         write('   Abschnitt (max.',AnzahlAbschnitte,') : ');
         readln(Abschnitt);
         write('   Lnge : ');
         readln(Lauf);

         dec(StrassenGroesse,Lauf);

         while Lauf>0 do
         begin
            Strasse^[Spur,Abschnitt+Lauf-1].Benutzt:=leer;
            if Strasse^[Spur,Abschnitt+Lauf-1].Gesperrt=RechteSpur then
               Strasse^[Spur+1,Abschnitt+Lauf-1].Gesperrt:=RechteSpur;
            Strasse^[Spur,Abschnitt+Lauf-1].Gesperrt:=ja;
            Strasse^[Spur,Abschnitt+Lauf-1].Geschwindigkeit:=0;
            dec(Lauf);
         end;
      end;

   write('Anzahl Auf-/Abfahrten : ');
   readln(AnzahlEinfahrten);
   if AnzahlEinfahrten>0 then
      for Zaehler:=1 to AnzahlEinfahrten do
      begin
         writeln(Zaehler,'.Auf-/Abfahrt');

         write('   Abschnitt (max.',AnzahlAbschnitte,') : ');
         readln(Abschnitt);
         write('   Verkehrsfluss (auf +, ab -): ');
         readln(Verkehrsfluss);

         for Lauf:=1 to MaxNormalTempo do
            Strasse^[1,Abschnitt+Lauf-1].Verkehrsfluss:=Verkehrsfluss;
      end;

   Treiber:=VGA;
   Modus:=VGAMed;
   initgraph(Treiber,Modus,'');
   FlipPages:=0;

   while not keypressed do
   begin
      ErgaenzeVerkehrslage;
      ZeigeVerkehrslage;
      SimuliereVerkehrslage;
      delay(10);
   end;

   closegraph;
end.