uses crt;

type tWorttyp  = (KeyWord,Sonstiges);
     tWort     = record
                    Wort     : string[40];
                    Stelle   : word;
                    Satz     : word;
                    Position : word;
                    Bezug    : word;
                 end;
     tText     = array[1..35000] of char;
     tSatz     = record
                    Stelle : word;
                    Laenge : word;
                 end;

var Woerter    : array[0..500] of tWort;
    WortZahl   : word;
    Gesamttext : tText;
    TextLaenge : longint;
    KeyWords   : array[1..100] of tWort;
    KeyZahl    : word;
    Saetze     : array[1..50] of tSatz;
    SatzZahl   : word;


procedure Einlesen(Dateiname: string);
var Datei      : file;
    Zeichen    : char;
    WortLaenge : word;
    SatzLaenge : word;
    Lauf       : word;
    Zaehler    : word;
    Position   : word;
begin
   assign(Datei,Dateiname);
   reset(Datei,1);

   TextLaenge:=filesize(Datei);

   blockread(Datei,Gesamttext,TextLaenge);
   close(Datei);

   Woerter[0].Satz:=0;
   Woerter[0].Wort:='';

   SatzZahl:=1;
   WortZahl:=1;
   WortLaenge:=0;
   SatzLaenge:=0;
   Position:=1;

   for Lauf:=1 to TextLaenge do
   begin
      Zeichen:=Gesamttext[Lauf];

      if (SatzLaenge>1) or (Zeichen>' ') then
         inc(SatzLaenge);

      if Zeichen in ['A'..'Z','a'..'z','','','','','','',''] then
         inc(WortLaenge)
      else begin
              if WortLaenge>0 then
              begin
                 Woerter[WortZahl].Position:=Position;
              with Woerter[WortZahl] do
              begin
                 Satz:=SatzZahl;
                 Stelle:=Lauf-WortLaenge;

                 Wort:='';
                 for Zaehler:=1 to WortLaenge do
                    Wort:=Wort+Gesamttext[Stelle+Zaehler-1];
              end;
                 WortLaenge:=0;
                 inc(WortZahl);
                 inc(Position);
              end;

              if Zeichen in [':','.'] then
              begin
                 Saetze[SatzZahl].Laenge:=SatzLaenge;
                 Saetze[SatzZahl].Stelle:=Lauf-SatzLaenge+1;

                 SatzLaenge:=0;
                 inc(SatzZahl);
                 Position:=1;
              end;
           end;
   end;

   if WortLaenge>0 then
   begin
      Woerter[WortZahl].Position:=Position;
      with Woerter[WortZahl] do
      begin
         Satz:=SatzZahl;
         Stelle:=Lauf-WortLaenge;

         Wort:='';
         for Zaehler:=1 to WortLaenge do
             Wort:=Wort+Gesamttext[Stelle+Zaehler-1];
      end;
   end
   else
      dec(WortZahl);

   Woerter[WortZahl+1].Satz:=0;
   Woerter[WortZahl+1].Wort:='';

   if SatzLaenge>0 then
   begin
      Saetze[SatzZahl].Laenge:=SatzLaenge;
      Saetze[SatzZahl].Stelle:=Lauf-SatzLaenge+1;
   end
   else
      dec(SatzZahl);
end;


procedure Typisierung;
var Lauf : word;
begin
   KeyZahl:=0;
   for Lauf:=1 to WortZahl do
   with Woerter[Lauf] do
      if (Gesamttext[Stelle] in ['A'..'Z','','','']) and
         (Position>1) then
      begin
         inc(KeyZahl);
         KeyWords[KeyZahl]:=Woerter[Lauf];
         KeyWords[KeyZahl].Bezug:=Lauf;
      end;
end;


procedure Sortieren;
   function WortAngleichen(Wort: string): string;
   var Lauf           : byte;
       Resultat       : string;
       NeuerBuchstabe : string[2];
   begin
      Resultat:='';

      for Lauf:=1 to length(Wort) do
      begin
         case Wort[Lauf] of
            '','': NeuerBuchstabe:='A';
            '','': NeuerBuchstabe:='O';
            '','': NeuerBuchstabe:='U';
            ''    : NeuerBuchstabe:='SS';
            else NeuerBuchstabe:=upcase(Wort[Lauf]);
         end;

         Resultat:=Resultat+NeuerBuchstabe;
      end;

      WortAngleichen:=Resultat;
   end;


   function WortDavorEinordnen(Wort1, Wort2: string): boolean;
   var MinWortLaenge : byte;
       Lauf          : byte;
       str1,str2     : string;
   begin
      str1:=WortAngleichen(Wort1)+' ';
      str2:=WortAngleichen(Wort2)+' ';

      MinWortLaenge:=length(Wort1);
      if length(Wort2)<MinWortLaenge then
         MinWortLaenge:=length(Wort2);

      Lauf:=1;
      while (Lauf<MinWortLaenge) and (str1[Lauf]=str2[Lauf]) do
         inc(Lauf);

      WortDavorEinordnen:=str2[Lauf]<str1[Lauf];
   end;

var SortLauf,SuchLauf : word;
    TauscheWort       : tWort;
begin
   for SortLauf:=1 to KeyZahl-1 do
      for SuchLauf:=SortLauf+1 to KeyZahl do
         if WortDavorEinordnen(KeyWords[SortLauf].Wort,
                               KeyWords[SuchLauf].Wort) then
         begin
            TauscheWort:=KeyWords[SortLauf];
            KeyWords[SortLauf]:=KeyWords[SuchLauf];
            KeyWords[SuchLauf]:=TauscheWort;
         end;
end;


procedure Ausgeben;
var WortLauf, SatzLauf : word;
begin
   for WortLauf:=1 to KeyZahl do
   begin
      for SatzLauf:=Saetze[KeyWords[WortLauf].Satz].Stelle to
          Saetze[KeyWords[WortLauf].Satz].Stelle+
          Saetze[KeyWords[WortLauf].Satz].Laenge-1 do
      begin
         if SatzLauf=KeyWords[WortLauf].Stelle then
            write(#10#13'   -> ');

         if Gesamttext[SatzLauf]>=' ' then
            write(Gesamttext[SatzLauf])
         else
            write(' ');

         if SatzLauf=KeyWords[WortLauf].Stelle+
            length(KeyWords[WortLauf].Wort) then
            write('   (Satz ',KeyWords[WortLauf].Satz,', Wort ',
                  KeyWords[WortLauf].Position,')'#10#13'        ');
      end;
      writeln;

      if WortLauf mod 4=3 then
         readln;
   end;
   readln;
end;


begin
   Einlesen('text3.txt');

   Typisierung;

   Sortieren;

   clrscr;
   writeln('Wrter   : ',WortZahl);
   writeln('Stze    : ',SatzZahl);
   writeln('KeyWords : ',KeyZahl);
   readln;

   Ausgeben;

   readln;
end.