uses crt;

const MaxWoerter = 1000;
      MaxSaetze  =  200;

type tWorttyp  = (KeyWord,Sonstiges);
     tWort     = record
                    Wort     : string;
                    Stelle   : word;
                    Satz     : word;
                    Position : word;
                    Bezug    : word;
                 end;
     tWoerter  = array[0..MaxWoerter] of ^tWort;
     tText     = array[1..65535] of char;
     tSatz     = record
                    Stelle : word;
                    Laenge : word;
                 end;
     tSaetze   = array[1..MaxSaetze] of ^tSatz;

var Woerter    : ^tWoerter;
    WortZahl   : word;
    Gesamttext : ^tText;
    TextLaenge : longint;
    KeyWords   : ^tWoerter;
    KeyZahl    : word;
    Saetze     : ^tSaetze;
    SatzZahl   : word;


procedure Einlesen(Dateiname: string);
var Datei      : file;
    Zeichen    : char;
    WortLaenge : word;
    SatzLaenge : word;
    Lauf       : word;
    Position   : word;
    Zaehler    : word;
begin
   assign(Datei,Dateiname);
   reset(Datei,1);

   TextLaenge:=filesize(Datei);

   new(Gesamttext);
   blockread(Datei,Gesamttext^,TextLaenge);
   close(Datei);

   new(Woerter);
   new(KeyWords);
   new(Saetze);

   SatzZahl:=1;
   WortZahl:=1;
   WortLaenge:=0;
   SatzLaenge:=0;
   Position:=1;

   new(Woerter^[0]);
   Woerter^[0]^.Satz:=0;
   Woerter^[0]^.Wort:='';

   for Lauf:=1 to TextLaenge do
   begin
      Zeichen:=Gesamttext^[Lauf];

      if (SatzLaenge>1) or (Zeichen>' ') then
         inc(SatzLaenge);

      if Zeichen in ['A'..'Z','a'..'z','','','','','','',''] then
         inc(WortLaenge)
      else begin
              if WortLaenge>0 then
              begin
                 new(Woerter^[WortZahl]);
                 Woerter^[WortZahl]^.Position:=Position;
              with Woerter^[WortZahl]^ do
              begin
                 Satz:=SatzZahl;
                 Stelle:=Lauf-WortLaenge;

                 Wort:='';
                 for Zaehler:=1 to WortLaenge do
                    Wort:=Wort+Gesamttext^[Stelle+Zaehler-1];
              end;
                 WortLaenge:=0;
                 inc(WortZahl);
                 inc(Position);
              end;

              if Zeichen in [':','.','!','?'] then
              begin
                 new(Saetze^[SatzZahl]);
                 Saetze^[SatzZahl]^.Laenge:=SatzLaenge;
                 Saetze^[SatzZahl]^.Stelle:=Lauf-SatzLaenge+1;

                 SatzLaenge:=0;
                 inc(SatzZahl);
                 Position:=1;
              end;
           end;
   end;

   if WortLaenge>0 then
   begin
      new(Woerter^[WortZahl]);
      Woerter^[WortZahl]^.Position:=Position;
      with Woerter^[WortZahl]^ do
      begin
         Satz:=SatzZahl;
         Stelle:=Lauf-WortLaenge;

         Wort:='';
         for Zaehler:=1 to WortLaenge do
             Wort:=Wort+Gesamttext^[Stelle+Zaehler-1];
      end;
   end
   else
      dec(WortZahl);

   new(Woerter^[Wortzahl+1]);
   Woerter^[WortZahl+1]^.Satz:=0;
   Woerter^[WortZahl+1]^.Wort:='';

   if SatzLaenge>0 then
   begin
      new(Saetze^[SatzZahl]);
      Saetze^[SatzZahl]^.Laenge:=SatzLaenge;
      Saetze^[SatzZahl]^.Stelle:=Lauf-SatzLaenge+1;
   end
   else
      dec(SatzZahl);
end;


procedure Typisierung;
var Lauf : word;
begin
   KeyZahl:=0;
   for Lauf:=1 to WortZahl do
   with Woerter^[Lauf]^ do
      if (Gesamttext^[Stelle] in ['A'..'Z','','','']) and
         (Position>1) then
      begin
         inc(KeyZahl);
         new(KeyWords^[KeyZahl]);
         KeyWords^[KeyZahl]^:=Woerter^[Lauf]^;
         KeyWords^[KeyZahl]^.Bezug:=Lauf;
      end;
end;


procedure Sortieren;
type tEinordnen = (ja,nein,gleich);

   function WortAngleichen(Wort: string): string;
   var Lauf           : byte;
       Resultat       : string;
       NeuerBuchstabe : string[2];
   begin
      Resultat:='';

      for Lauf:=1 to length(Wort) do
      begin
         case Wort[Lauf] of
            '','': NeuerBuchstabe:='A';
            '','': NeuerBuchstabe:='O';
            '','': NeuerBuchstabe:='U';
            ''    : NeuerBuchstabe:='SS';
            else NeuerBuchstabe:=upcase(Wort[Lauf]);
         end;

         Resultat:=Resultat+NeuerBuchstabe;
      end;

      WortAngleichen:=Resultat;
   end;


   function WortDavorEinordnen(str1, str2: string): tEinordnen;
   var MinWortLaenge : byte;
       Lauf          : byte;
       Wort1,Wort2   : string;
   begin
      Wort1:=WortAngleichen(str1)+' ';
      Wort2:=WortAngleichen(str2)+' ';

      MinWortLaenge:=length(Wort1);
      if length(Wort2)<MinWortLaenge then
         MinWortLaenge:=length(Wort2);

      Lauf:=1;
      while (Lauf<MinWortLaenge) and (Wort1[Lauf]=Wort2[Lauf]) do
         inc(Lauf);

      if Wort2[Lauf]<Wort1[Lauf] then
         WortDavorEinordnen:=ja;
      if Wort2[Lauf]>Wort1[Lauf] then
         WortDavorEinordnen:=nein;
      if Wort2[Lauf]=Wort1[Lauf] then
         WortDavorEinordnen:=gleich;
   end;


var SortLauf,SuchLauf : word;
    TauscheWort       : tWort;
    Zaehler1,Zaehler2 : word;
    Einordnen         : tEinordnen;
begin
   for SortLauf:=1 to KeyZahl-1 do
      for SuchLauf:=SortLauf+1 to KeyZahl do
      begin
         Einordnen:=WortDavorEinordnen(KeyWords^[SortLauf]^.Wort,
                                       KeyWords^[SuchLauf]^.Wort);

         if Einordnen=gleich then
         begin
            Zaehler1:=KeyWords^[SortLauf]^.Bezug;
            Zaehler2:=KeyWords^[SuchLauf]^.Bezug;

            while (KeyWords^[SortLauf]^.Satz=Woerter^[Zaehler1]^.Satz) and
                  (KeyWords^[SuchLauf]^.Satz=Woerter^[Zaehler2]^.Satz) and
                  (Einordnen=gleich) do
            begin
               dec(Zaehler1);
               dec(Zaehler2);
               Einordnen:=WortDavorEinordnen(Woerter^[Zaehler1]^.Wort,
                                             Woerter^[Zaehler2]^.Wort);
            end;
         end;

         if Einordnen=gleich then
         begin
            Zaehler1:=KeyWords^[SortLauf]^.Bezug;
            Zaehler2:=KeyWords^[SuchLauf]^.Bezug;

            while (KeyWords^[SortLauf]^.Satz=Woerter^[Zaehler1]^.Satz) and
                  (KeyWords^[SuchLauf]^.Satz=Woerter^[Zaehler2]^.Satz) and
                  (Einordnen=gleich) do
            begin
               inc(Zaehler1);
               inc(Zaehler2);
               Einordnen:=WortDavorEinordnen(Woerter^[Zaehler1]^.Wort,
                                             Woerter^[Zaehler2]^.Wort);
            end;
         end;

         if Einordnen=ja then
         begin
            TauscheWort:=KeyWords^[SortLauf]^;
            KeyWords^[SortLauf]^:=KeyWords^[SuchLauf]^;
            KeyWords^[SuchLauf]^:=TauscheWort;
         end;
      end;
end;


procedure Ausgeben;
var WortLauf, SatzLauf : word;
begin
   for WortLauf:=1 to KeyZahl do
   begin
      for SatzLauf:=Saetze^[KeyWords^[WortLauf]^.Satz]^.Stelle to
          Saetze^[KeyWords^[WortLauf]^.Satz]^.Stelle+
          Saetze^[KeyWords^[WortLauf]^.Satz]^.Laenge-1 do
      begin
         if SatzLauf=KeyWords^[WortLauf]^.Stelle then
            write(#10#13'   -> ');

         if Gesamttext^[SatzLauf]>=' ' then
            write(Gesamttext^[SatzLauf])
         else
            write(' ');

         if SatzLauf=KeyWords^[WortLauf]^.Stelle+
            length(KeyWords^[WortLauf]^.Wort) then
            write('   (Satz ',KeyWords^[WortLauf]^.Satz,', Wort ',
                  KeyWords^[WortLauf]^.Position,')'#10#13'        ');
      end;
      writeln;
      writeln;

      if WortLauf mod 4=3 then
      begin
         readln;
         clrscr;
      end;
   end;
end;


begin
   Einlesen('text3.txt');

   Typisierung;

   Sortieren;

   clrscr;
   writeln('Wrter   : ',WortZahl);
   writeln('Stze    : ',SatzZahl);
   writeln('KeyWords : ',KeyZahl);
   readln;

   Ausgeben;

   readln;
end.